#include <amxmodx>
#include <amxmisc>
#include <fun>
#include <cstrike>
#include <colorchat>
#include <hamsandwich>


new const g_szDefaultContent[ ][ ] = {
	";  Here you can add Clan Tags.",
	"",
	"; McD |",
	"; [MoZZart]",
	"; PaintBall ->"
};

new Array:g_szClanTags;
new g_szTagCount = 0;

new Ham:Ham_Player_ResetMaxSpeed = Ham_Item_PreFrame ;
new iCvars[ 4 ]; 

public plugin_init( ) {
	
	register_plugin( "ClanTag System / Cvar + ini", "1.0", "Maka" );
	
	register_logevent( "LogEvent_RoundStart", 2, "1=Round_Start" );
	RegisterHam( Ham_Player_ResetMaxSpeed, "player", "fw_HamResetMaxSpeedPost", 1 ) ;
	
	iCvars[ 0 ] = register_cvar( "Speed", "36.0" ) ;
	iCvars[ 1 ] = register_cvar( "Gravity", "0.7" ) ;
	
	iCvars[ 2 ] = register_cvar( "Health.", "30" ) ;
	iCvars[ 3 ] = register_cvar( "Armor.", "200" ) ;
	
	g_szClanTags = ArrayCreate( 32, 1 );
	LoadClanTags( );
}


public LogEvent_RoundStart( )
{
	for ( new i = 1; i <= get_maxplayers( ); i ++ )
	{
		if ( is_user_alive( i ) )
		{
			CheckingClanInfo( i )
		}
	}
}

public plugin_end() {
	ArrayDestroy(g_szClanTags);
}

LoadClanTags( ) {
	
	new szFile[ 128 ];
	get_configsdir( szFile, sizeof( szFile ) - 1 );
	format( szFile, sizeof( szFile ) - 1, "%s/ClanTags.ini", szFile );
	
	if( !file_exists( szFile ) ) {
		new File = fopen( szFile, "wt" );
		
		if( File ) {
			for( new i = 0; i < sizeof( g_szDefaultContent ); i ++ ) {
				fprintf( File, "%s^n", g_szDefaultContent[ i ] );
			}
			fclose( File );
		}
	}
	
	new File = fopen( szFile, "rt" );
	if( File ) {
		new szText[ 32 ];
		while( !feof( File ) ) {
			fgets( File, szText, sizeof( szText ) - 1 );
			trim( szText );
			
			if( szText[ 0 ] && szText[ 0 ] != ';' ) {
				ArrayPushString( g_szClanTags, szText );
				g_szTagCount ++;
			}
		}
		fclose( File );
	}
}

public CheckingClanInfo( id ) {
	
	if( !is_user_alive( id ) )
		return PLUGIN_HANDLED;
	
	new szNameClan[ 32 ], szClanTags[ 32 ];
	get_user_name( id, szNameClan, sizeof( szNameClan ) - 1 );
	
	for( new i = 0; i < g_szTagCount; i ++ ) {
		ArrayGetString( g_szClanTags, i, szClanTags, sizeof( szClanTags ) - 1 );
		
		if( strfind( szNameClan, szClanTags, 0 ) != -1 ) {
			
			set_user_maxspeed( id, get_user_maxspeed( id ) + get_pcvar_float( iCvars[ 0 ] ) ) ;
			set_user_gravity( id, get_pcvar_float( iCvars[ 1 ] ) ) ;
			
			set_user_health(id, get_user_health(id) + get_pcvar_num( iCvars[ 2 ])) 
			set_user_armor(id, get_user_armor(id) + get_pcvar_num( iCvars[ 3 ]));
			
			
			new Float:iSpeed = get_user_maxspeed( id );
			new Float:iGravity = get_user_gravity( id ) * 100.0; 
			
			ColorChat( id, GREEN, "[Clan System] ^1Rewards for ClanTag ^3%s:  ^4+%.1f%% Speed ^1/ ^4-%.1f%% Gravity ^1/ ^4+%d Health ^1/ ^4+%d Armor", szClanTags, iSpeed, iGravity, get_pcvar_num(iCvars[ 2 ]), get_pcvar_num(iCvars[ 3 ]));
			break;
		}
	}
	return PLUGIN_CONTINUE;
}

public fw_HamResetMaxSpeedPost( id )
{
	if( ! is_user_alive( id ) )
		return HAM_IGNORED;
	
	set_user_maxspeed( id, get_user_maxspeed( id ) + get_pcvar_float( iCvars[ 0 ] ) );
	return HAM_IGNORED;
}
